// MySysInfo.cpp : implementation file
//

#include "stdafx.h"
#include "AllgemBeispiele.h"
#include "MySysInfo.h"

#include "RegistryManip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MySysInfo dialog


MySysInfo::MySysInfo(CWnd* pParent /*=NULL*/)
	: CDialog(MySysInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(MySysInfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void MySysInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MySysInfo)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MySysInfo, CDialog)
	//{{AFX_MSG_MAP(MySysInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MySysInfo message handlers

BOOL MySysInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();

//////////

	ReadUserInfoFromReg();
	
//////////
	
	CRegistryManip clRegistryManip;

	BOOL bRes = FALSE;
	CStringArray acsKeyList, acsValList;
	CString cstrSubKey;

	// testen GetNamesOfAllSubKeys() mit 2 unterschiedlichen SubKeys
	for (int j = 0; j < 2; j++)
	{
		if (j == 0)
		{
			// hier sind keine Unterverzeichnisse mehr zu finden
			cstrSubKey = _T("SOFTWARE\\Microsoft\\Web Service Providers");
		}
		else
		{
			// hier sind welche
			cstrSubKey = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Setup");
		}

		clRegistryManip.GetNamesOfAllSubKeys(	HKEY_LOCAL_MACHINE, 
												cstrSubKey, 
												acsKeyList);

		int nCount = acsKeyList.GetSize();
		CString cstrVal, cstrKeyName, cstrResStr ;

		for (int i = 0; i < nCount; i++)
		{
			cstrKeyName = acsKeyList.GetAt(i);

			cstrResStr.Format ("Liste von Unterverzeichnissen: Index = %d *** Verzeichnis = %s *** \n", i, cstrKeyName);
			TRACE (cstrResStr);
		}

		acsKeyList.RemoveAll(); 
		acsValList.RemoveAll();
	}

//////////////

	BOOL bWasFound = FALSE;
	int nValStrID = 2000;
	int nValFlag = 50;
	CString cstrNameStrId = c_strStringIdReg, cstrNameFlag = c_strFlagReg;

	// testen DeleteInfoFromRegistry: SubKey und Parameter
//	bRes = clRegistryManip.DeleteInfoFromRegistry(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina"), cstrNameStrId); 
//	bRes = clRegistryManip.DeleteInfoFromRegistry(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina"), NULL); 
//	bRes = clRegistryManip.DeleteInfoFromRegistry(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina"), _T("Param_bin")); 

	// testen ChangeOneVal - ndern / eintragen Werte
	bRes = clRegistryManip.ChangeOneVal(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina"), 
										cstrNameStrId, cstrNameFlag, nValStrID, nValFlag, 
										bWasFound);

/*
	nValStrID = 3000;
	nValFlag = 100;
	bRes = clRegistryManip.ChangeOneVal(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina"), 
										cstrNameStrId, cstrNameFlag, nValStrID, nValFlag, 
										bWasFound);
*/

	// testen Erzeugen vom Ordner (subkey):
	cstrNameStrId = _T("Param_test");
	bRes = clRegistryManip.CreateNewKey(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina\\"), _T("Test") );
	// testen Eintragen vom neuen Wert fr ein Parameter
	BOOL bIsInReg = FALSE;
	bRes = clRegistryManip.InputNewValue(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina\\Test"), 
										cstrNameStrId, 5, bIsInReg, REG_DWORD);

	// testen Eintragen vom neuen Wert fr ein Parameter
//	cstrNameStrId = _T("Param_bin");
	cstrNameStrId = _T("Param_dword");
	bRes = clRegistryManip.InputNewValue(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Irina\\"), 
										cstrNameStrId, 5, bIsInReg, REG_DWORD);

	// testen GetCountOfSubKeys()
	unsigned long nCountOfSKeys = 0;
	bRes = clRegistryManip.GetCountOfSubKeysAll(HKEY_LOCAL_MACHINE, 
											_T("SOFTWARE\\Irina\\Test\\"), nCountOfSKeys); 

	acsKeyList.RemoveAll(); 
	acsValList.RemoveAll();


//////////////
//////////////

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void MySysInfo::ReadUserInfoFromReg()
{
	char buf[256], strTmp[256], strAll[256];
	DWORD nSize = sizeof(buf);

	GetUserName(buf, &nSize);
	CEdit* pEdit = (CEdit*)GetDlgItem(IDC_NAME); 
	pEdit->SetWindowText(buf); 
///
	strcpy(buf, "");
	GetComputerName(buf, &nSize);
	pEdit = (CEdit*)GetDlgItem(IDC_COMP); 
	pEdit->SetWindowText(buf); 
///
    CString str("");
    OSVERSIONINFO vers;
    bool bIsWin95 = false, bIsWin98 = false, bIsWinNt351 = false, bIsWinNT4 = false, 
         bIsWinMe = false, bIsWin2000 = false, bIsWinXP = false;
	
    vers.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&vers);

    // check windows version
    bIsWin95 = (vers.dwMajorVersion == 4) && (vers.dwMinorVersion == 0) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS);

    bIsWin98 = (vers.dwMajorVersion == 4) && (vers.dwMinorVersion == 10) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS);

    bIsWinNt351 = (vers.dwMajorVersion == 3) && (vers.dwMinorVersion == 51) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_NT);

    bIsWinNT4 = (vers.dwMajorVersion == 4) && (vers.dwMinorVersion == 0) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_NT);

    bIsWinMe = (vers.dwMajorVersion == 4) && (vers.dwMinorVersion == 90) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS);

    bIsWin2000 = (vers.dwMajorVersion == 5) && (vers.dwMinorVersion == 0) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_NT);

    bIsWinXP = (vers.dwMajorVersion == 5) && (vers.dwMinorVersion == 1) && 
               (vers.dwPlatformId == VER_PLATFORM_WIN32_NT);

	if (bIsWin95)
	{
		str = str + " * " + "Win95";
	}
	if (bIsWin98)
	{
		str = str + " * " + "Win98";
	}	
	if (bIsWinNt351)
	{
		str = str + " * " + "WinNt351";
	}
	if (bIsWinNT4)
	{
		str = str + " * " + "WinNT4";
	}
	if (bIsWinMe)
	{
		str = str + " * " + "WinMe";
	}
	if (bIsWin2000)
	{
		str = str + " * " + "Win2000";
	}
	if (bIsWinXP)
	{
		str = str + " * " + "WinXP";
	}

    pEdit = (CEdit*)GetDlgItem(IDC_VERSION);
    pEdit->SetWindowText(str); 
///
	CRegistryManip clRegistryManip;
	strcpy(buf, "");
	clRegistryManip.getInfoFromRegistry(HKEY_CURRENT_USER, 
										"Software\\Microsoft\\MS Setup (ACME)\\User Info", 
										"DefCompany", buf);

    pEdit = (CEdit*)GetDlgItem(IDC_DEFCOMPANY);
    pEdit->SetWindowText(buf); 
///	
	strcpy(buf, "");
	clRegistryManip.getInfoFromRegistry(HKEY_CURRENT_USER, 
										"Software\\Microsoft\\MS Setup (ACME)\\User Info", 
										"DefName", buf);

    pEdit = (CEdit*)GetDlgItem(IDC_DEFNAME);
    pEdit->SetWindowText(buf); 

//////////////////////

	// Lnderspezifische Einstellungen
	// ================================

	strcpy(strAll, "");
	strcpy(buf, "");
	pEdit = (CEdit*)GetDlgItem(IDC_COUNTRY_SET);

	GetNumberFormat(LOCALE_SYSTEM_DEFAULT, 0, TEXT("5.5"), NULL, buf, nSize);
	sprintf(strTmp, "Zahl : %s \r\n", buf);
	strcat(strAll, strTmp);

	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SENGLANGUAGE, buf, nSize);
	sprintf(strTmp, "Sprache : %s \r\n", buf);
	strcat(strAll, strTmp);

//	GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SDECIMAL, strVal, sizeof(strVal));
	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SDECIMAL, buf, nSize);
	sprintf(strTmp, "Trennzeichen (dez.): %s \r\n", buf);
	strcat(strAll, strTmp);

	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_STHOUSAND, buf, nSize);
	sprintf(strTmp, "Trennzeichen (grupp.): %s \r\n", buf);
	strcat(strAll, strTmp);

	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_IDIGITS, buf, nSize);
	sprintf(strTmp, "Anzahl von dez. Zeichen: %s \r\n", buf);
	strcat(strAll, strTmp);

	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SSHORTDATE, buf, nSize);
	sprintf(strTmp, "Datum (kurz) : %s \r\n", buf);
	strcat(strAll, strTmp);
	
	pEdit->SetWindowText(strAll); 
	
}